/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDataquierLogicRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierLogic extends TableImpl<VDataquierLogicRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier_logic</code>
     */
    public static final VDataquierLogic V_DATAQUIER_LOGIC = new VDataquierLogic();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierLogicRecord> getRecordType() {
        return VDataquierLogicRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_logic.fk_element</code>.
     */
    public final TableField<VDataquierLogicRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logic.dependency</code>.
     */
    public final TableField<VDataquierLogicRecord, String> DEPENDENCY = createField(DSL.name("dependency"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logic.softlimit</code>.
     */
    public final TableField<VDataquierLogicRecord, String> SOFTLIMIT = createField(DSL.name("softlimit"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logic.hardlimit</code>.
     */
    public final TableField<VDataquierLogicRecord, String> HARDLIMIT = createField(DSL.name("hardlimit"), SQLDataType.CLOB, this, "");

    private VDataquierLogic(Name alias, Table<VDataquierLogicRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierLogic(Name alias, Table<VDataquierLogicRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_logic" as  SELECT h.key_element AS fk_element,
          string_agg(DISTINCT lc1.cond, '|'::text) AS dependency,
          string_agg(DISTINCT lc2.cond, '|'::text) AS softlimit,
          string_agg(DISTINCT lc3.cond, '|'::text) AS hardlimit
         FROM (((common_dd.t_core_element_hierarchy h
           LEFT JOIN common_dd.v_dataquier_logiccond lc1 ON (((h.key_element = lc1.fk_element) AND (lc1.logictype_descr = 'logictype.dependency'::text))))
           LEFT JOIN common_dd.v_dataquier_logiccond lc2 ON (((lc2.fk_element = h.key_element) AND (lc2.logictype_descr = 'logictype.validation.warn'::text))))
           LEFT JOIN common_dd.v_dataquier_logiccond lc3 ON (((lc3.fk_element = h.key_element) AND (lc3.logictype_descr = 'logictype.validation.error'::text))))
        GROUP BY h.key_element;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_logic</code> table
     * reference
     */
    public VDataquierLogic(String alias) {
        this(DSL.name(alias), V_DATAQUIER_LOGIC);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_logic</code> table
     * reference
     */
    public VDataquierLogic(Name alias) {
        this(alias, V_DATAQUIER_LOGIC);
    }

    /**
     * Create a <code>common_dd.v_dataquier_logic</code> table reference
     */
    public VDataquierLogic() {
        this(DSL.name("v_dataquier_logic"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierLogic as(String alias) {
        return new VDataquierLogic(DSL.name(alias), this);
    }

    @Override
    public VDataquierLogic as(Name alias) {
        return new VDataquierLogic(alias, this);
    }

    @Override
    public VDataquierLogic as(Table<?> alias) {
        return new VDataquierLogic(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogic rename(String name) {
        return new VDataquierLogic(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogic rename(Name name) {
        return new VDataquierLogic(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogic rename(Table<?> name) {
        return new VDataquierLogic(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic where(Condition condition) {
        return new VDataquierLogic(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogic where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogic where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogic where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogic where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogic whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
